﻿<%@ Page Title="Home Page" Language="C#" MasterPageFile="~/Site.master" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="Grid.Default" %>
<%@MasterType VirtualPath="~/Site.Master" %>

<%@ Register Assembly="Syncfusion.EJ.Web, Version=12.3400.0.36, Culture=neutral, PublicKeyToken=3D67ED1F87D44C89" Namespace="Syncfusion.JavaScript.Web" TagPrefix="ej" %>
<%@ Register Assembly="Syncfusion.EJ, Version=12.3400.0.36, Culture=neutral, PublicKeyToken=3D67ED1F87D44C89" Namespace="Syncfusion.JavaScript.Models" TagPrefix="ej" %>

<asp:Content ID="HeaderContent" runat="server" ContentPlaceHolderID="HeadContent">
    <link href="Styles/flat-lime/ej.web.all.min.css" rel="stylesheet" />
    <script src="Scripts/jquery-1.10.2.min.js" type="text/javascript"></script>
    <script src="Scripts/jquery.easing-1.3.min.js" type="text/javascript"></script>
    <script src="Scripts/jquery.globalize.min.js" type="text/javascript"></script>
    <script src="Scripts/jsrender.min.js" type="text/javascript"></script>
    <script src="Scripts/ej/ej.web.all.min.js" type="text/javascript"></script>
    <style type="text/css">
        .ship
        { visibility:collapse; }
    </style>
</asp:Content>
<asp:Content ID="BodyContent" runat="server" ContentPlaceHolderID="MainContent">
    <div>
        <ej:Grid ID="FlatGrid" runat="server" AllowSorting="True" AllowPaging="True"
            OnServerEditRow="EditEvents_ServerEditRow" OnServerAddRow="EditEvents_ServerAddRow" 
            OnServerDeleteRow="EditEvents_ServerDeleteRow" editMode="dialogtemplate" >
            <ClientSideEvents ActionComplete="complete" EndAdd="endAdd" EndDelete="endDelete" EndEdit="endEdit" Create="create" />
            <Columns>
                <ej:Column Field="OrderID" HeaderText="Order ID" IsPrimaryKey="True" TextAlign="Right" Width="75" />
                <ej:Column Field="CustomerID" HeaderText="Customer ID" Width="80" />
                <ej:Column Field="EmployeeID" HeaderText="Employee ID" TextAlign="Right" Width="75" />
                <ej:Column Field="Freight" HeaderText="Freight" TextAlign="Right" Width="75" Format="{0:C}" />
                <ej:Column Field="OrderDate" HeaderText="Order Date" TextAlign="Right" Width="80" Format="{0:MM/dd/yyyy}" />
                <ej:Column Field="ShipCountry" HeaderText="Ship Country" Width="110" />
                <ej:Column Field="ShipCity" HeaderText="Ship City" Width="110" />
                <ej:Column Field="Adjacent" Width="0" Template="true" TemplateID="#templateAdjacent"/>
                <ej:Column Field="Priority" Width="30" EditType="Boolean" />
                <ej:Column Field="C" Width="0" Template="true" /><%-- 9 --%>
                <ej:Column Field="E" Width="0" Template="true" />
                <ej:Column Field="F" Width="0" Template="true" />
                <ej:Column Field="G" Width="0" Template="true" />
                <ej:Column Field="S" Width="0" Template="true" /><%-- 13 --%>
            </Columns>
            <EditSettings AllowEditing="True" AllowAdding="True" AllowDeleting="True" EditMode="dialogtemplate" DialogEditorTemplateID="#template"></EditSettings>
            <ToolbarSettings ShowToolbar="True" ToolbarItems="add,edit,delete,update,cancel"></ToolbarSettings>
        </ej:Grid>
    </div>
    
    <script type="text/x-jsrender" id ="templateAdjacent">
         {{for bikes}}
            <span>{{>value}}</span> 
            <span>{{>Text}}</span><br />
         {{/for}}
    </script>
    
    <script type="text/template" id="template">
        <b>Order Details</b>
        <table cellspacing="10">
            <tr>
                <td style="text-align: right;">Order ID
                </td>
                <td style="text-align: left">
                    <input id="OrderID" name="OrderID" value="{{: OrderID}}" disabled="disabled"
                        class="e-field e-ejinputtext valid e-disable" style="text-align: right; width: 116px; height: 28px" />
                </td>
                <td style="text-align: right;">Customer ID
                </td>
                <td style="text-align: left">
                    <input id="CustomerID" name="CustomerID" value="{{: CustomerID}}" class="e-field e-ejinputtext valid"
                        style="width: 116px; height: 28px" />
                </td>
            </tr>
            <tr>
                <td style="text-align: right;">Freight</td>
                <td style="text-align: left">
                    <input type="text" id="Freight" name="Freight" value="{{:Freight}}" style="text-align: right;" />
                </td>
                <td>Priority</td>
                <td>
                    <input id="Priority" name="Priority" type="checkbox" class="e-field e-ejcheckbox valid" style="width:20px;" value="{{:Priority}}"/>
                </td>
            </tr>
            <tr>
                <td style="text-align: right;">Ship Country</td>
                <td style="text-align: left">
                    <select id="ShipCountry" name="ShipCountry" onChange="_Change(this);">
                        <option value="Canada">Canada</option>
                        <option value="England">England</option>
                        <option value="France">France</option>
                        <option value="Germany">Germany</option>
                        <option value="Spain">Spain</option>
                    </select>
                </td>
                <td style="text-align: right;">ShipCity
                </td>
                <td style="text-align: left">
                    <select id="ShipCity" name="ShipCity" />
                </td>
            </tr>
            <tr class="ship">
                <td style="text-align: right;">Agacent
                </td>
                <td style="text-align: left">
                    <input id="Agacent" name="Agacent" class="e-field e-ejinputtext valid"
                        style="width: 116px; height: 28px" value="{{:Agacent}}" />
                </td>
            </tr>
        </table>
    </script>
    <script type="text/javascript">
        
        function endAdd(args) {
            $("#FlatGrid").ejWaitingPopup("show");
        }
        function endDelete(args) {
            $("#FlatGrid").ejWaitingPopup("show");
        }
        function endEdit(args) {
            $("#FlatGrid").ejWaitingPopup("show");
        }
        
        function complete(args) {
            if (args.requestType == "refresh" || args.requestType == "save") {
                $("#FlatGrid").ejWaitingPopup("hide");
            }
            if ((args.requestType == "beginedit" || args.requestType == "add") && args.model.editSettings.editMode == "dialogtemplate") {

                $("#Freight").ejNumericTextbox({ value: parseFloat($("#Freight").val()), width: "116px", height: "28px", decimalPlaces: 2 });
                $("#Freight").css({ 'text-align': 'left' });

                //to change checkbox size while adding & editing the records
                if ($("#Priority").val() == "true")
                    $("#Priority").ejCheckBox({ size: "medium", checked: true });
                else
                    $("#Priority").ejCheckBox({ size: "medium", checked: false });

                var resp = args.row.children().eq(5).text();
                if (resp == 'Canada') {
                    var State = 8;
                }
                else if (resp == 'England') {
                    var State = 9;
                }
                else if (resp == 'France') {
                    var State = 10;
                }
                else if (resp == 'Germany') {
                    var State = 11;
                }
                else if (resp == 'Spain') {
                    var State = 12;
                }
                if (args.requestType == "beginedit") {
                    $("#OrderID").attr("disabled", "disabled");
                    $("#ShipCountry").ejDropDownList({ width: '116px', change: '_Change' }).ejDropDownList("setSelectedValue", args.row.children().eq(5).text());
                    $("#ShipCity").ejDropDownList({ width: '116px', dataSource: this.model.columns[State].dataSource }).ejDropDownList("setSelectedValue", args.row.children().eq(6).text());

                    $("#Agacent").ejDropDownList({ width: '116px', dataSource: this.model.columns[7].dataSource }).ejDropDownList("setSelectedValue", args.row.children().eq(7).text());
                }
                else {
                    $("#ShipCountry").ejDropDownList({ width: '116px', change: '_Change' });
                    $("#ShipCity").ejDropDownList({ width: '116px', dataSource: this.model.columns[State].dataSource });
                    $("#Agacent").ejDropDownList({ width: '116px', dataSource: this.model.columns[7].dataSource });
                }
                
            }
        }

        function _Change(args) {
            var resp = args.selectedText;  // the Country dropdown selected value
            var gridObj = $("#FlatGrid").data("ejGrid"); //the grid
            if (resp == 'Canada') {
                var State = 8;
            }
            else if (resp == 'England') {
                var State = 9;
            }
            else if (resp == 'France') {
                var State = 10;
            }
            else if (resp == 'Germany') {
                var State = 11;
            }
            else if (resp == 'Spain') {
                var State = 12;
            }

            gridObj.model.columns[6].dataSource = gridObj.model.columns[State];
            gridObj.columns(gridObj.model.columns[6], 'update');
        }
    </script>
</asp:Content>
