﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Remoting.Messaging;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.JavaScript.Models;
using Syncfusion.JavaScript.Web;

namespace Grid
{
    public partial class Default : System.Web.UI.Page
    {
        List<Orders> order = new List<Orders>();

        protected void Page_Load(object sender, EventArgs e)
        {
            BindDataSource();
        }


        private void BindDataSource()
        {
            List<string> countries = new List<string>()
	        {
	            "Canada", "England", "France", "Germany", "Spain"
	        };
            List<string> CCities = new List<string>()
	        {
	            "Tsawassen", "Winnipeg", "Toronto", "Calgary", "Windsor"
	        };
            List<string> ECities = new List<string>()
	        {
	            "Cholchester", "New Castle", "Surry", "Bristol", "Manchester"
	        };
            List<string> FCities = new List<string>()
	        {
	            "Marseille", "Niece", "Metz", "Rennes", "La Rochelle"
	        };
            List<string> GCities = new List<string>()
	        {
	            "Berlin", "Bonn", "Dresden", "Potsdam", "Ulm"
	        };
            List<string> SCities = new List<string>()
	        {
	            "Madrid", "Andalusia", "Cádiz", "Pueblos Blancos", "Valencia"
	        };

            int code = 10000;
            for (int i = 1; i < 10; i++)
            {
                order.Add(new Orders(code + 1, "ALFKI", i + 0, 2.3 * i, new DateTime(1991, 05, 15), "Berlin", true, "Germany"));
                order.Add(new Orders(code + 2, "ANATR", i + 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid", false, "Spain"));
                order.Add(new Orders(code + 3, "ANTON", i + 1, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester", true, "England"));
                order.Add(new Orders(code + 4, "BLONP", i + 3, 5.3 * i, new DateTime(1930, 10, 22), "Marseille", false, "France"));
                order.Add(new Orders(code + 5, "BOLID", i + 4, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen", true, "Canada"));
                code += 5;
            }
            this.FlatGrid.DataSource = order;
            this.FlatGrid.Columns.ElementAt(8).DataSource = CCities;
            this.FlatGrid.Columns.ElementAt(9).DataSource = ECities;
            this.FlatGrid.Columns.ElementAt(10).DataSource = FCities;
            this.FlatGrid.Columns.ElementAt(11).DataSource = GCities;
            this.FlatGrid.Columns.ElementAt(12).DataSource = SCities;

            this.FlatGrid.DataBind();
        }

        protected void EditEvents_ServerEditRow(object sender, GridEventArgs e)
        {
            EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void EditEvents_ServerAddRow(object sender, GridEventArgs e)
        {
            EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void EditEvents_ServerDeleteRow(object sender, GridEventArgs e)
        {
            EditAction(e.EventType, e.Arguments["data"]);
        }

        protected void EditAction(string eventType, object record)
        {
            List<Orders> data = Session["DataSource"] as List<Orders>;
            Dictionary<string, object> KeyVal = record as Dictionary<string, object>;
            if (eventType == "endEdit")
            {
                Orders value = new Orders();
                foreach (KeyValuePair<string, object> keyval in KeyVal)
                {

                    if (keyval.Key == "OrderID")
                    {
                        value = data.Where(d => d.OrderID == (int)keyval.Value).FirstOrDefault();
                        value.OrderID = Convert.ToInt32(keyval.Value);
                    }
                    else if (keyval.Key == "CustomerID")
                        value.CustomerID = Convert.ToString(keyval.Value);
                    else if (keyval.Key == "EmployeeID")
                        value.EmployeeID = Convert.ToInt32(keyval.Value);
                    else if (keyval.Key == "Freight")
                        value.Freight = Convert.ToDouble(keyval.Value);
                    else if (keyval.Key == "ShipCountry")
                        value.ShipCountry = Convert.ToString(keyval.Value);
                    else if (keyval.Key == "ShipCity")
                        value.ShipCity = Convert.ToString(keyval.Value);
                    else if (value.Adjacent == "Adjacent")
                        value.Adjacent = Convert.ToString(keyval.Value);
                    else if (keyval.Key == "Priority")
                        value.Priority = Convert.ToBoolean(keyval.Value);
                }
            }

            else if (eventType == "endAdd")
            {
                Orders newRecord = new Orders();
                foreach (KeyValuePair<string, object> keyval in KeyVal)
                {
                    if (keyval.Value != string.Empty)
                    {
                        if (keyval.Key == "OrderID")
                            newRecord.OrderID = Convert.ToInt32(keyval.Value);
                        else if (keyval.Key == "CustomerID")
                            newRecord.CustomerID = Convert.ToString(keyval.Value);
                        else if (keyval.Key == "EmployeeID")
                            newRecord.EmployeeID = Convert.ToInt32(keyval.Value);
                        else if (keyval.Key == "Freight")
                            newRecord.Freight = Convert.ToDouble(keyval.Value);
                        else if (keyval.Key == "ShipCity")
                            newRecord.ShipCity = Convert.ToString(keyval.Value);
                        else if (keyval.Key == "ShipCountry")
                            newRecord.ShipCountry = Convert.ToString(keyval.Value);
                        else if (keyval.Key == "Adjacent")
                            newRecord.Adjacent = Convert.ToString(keyval.Value);
                        else if (keyval.Key == "Priority")
                            newRecord.Priority = Convert.ToBoolean(keyval.Value);
                    }
                }
                data.Insert(0, newRecord);
            }

            else if (eventType == "endDelete")
            {
                foreach (KeyValuePair<string, object> keyval in KeyVal)
                {
                    if (keyval.Key == "OrderID")
                    {
                        Orders value = data.Where(d => d.OrderID == (int)keyval.Value).FirstOrDefault();
                        data.Remove(value);
                    }
                }
            }
            Session["DataSource"] = data;
            this.FlatGrid.DataSource = data;
            this.FlatGrid.DataBind();
        }

        [Serializable]
        public class Orders
        {
            public Orders()
            {

            }
            public Orders(long OrderId, string CustomerId, int EmployeeId, double Freight, DateTime OrderDate, string ShipCity, bool priority, string ShipCountry
                )
            {
                this.OrderID = OrderId;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.ShipCountry = ShipCountry;
                this.ShipCity = ShipCity;
                this.Priority = priority;
            }
            public long OrderID { get; set; }
            public string CustomerID { get; set; }
            public int EmployeeID { get; set; }
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipCountry { get; set; }
            public string ShipCity { get; set; }
            public string Adjacent { get; set; }
            public Boolean Priority { get; set; }
        }
    }
}
